package prjaoadlwithcm.views;


import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.URLConnection;
import java.rmi.activation.Activator;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;


import org.eclipse.osgi.framework.internal.core.BundleHost;
import org.eclipse.osgi.framework.internal.core.BundleURLConnection;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.internal.intro.impl.model.util.BundleUtil;
import org.eclipse.ui.part.*;
import org.eclipse.ui.part.EditorInputTransfer.EditorInputData;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.Plugin;
import org.eclipse.emf.ecore.*;
import org.eclipse.emf.cdo.*;
import org.eclipse.emf.common.EMFPlugin.EclipsePlugin;
import org.eclipse.emf.common.ui.EclipseUIPlugin;
import org.eclipse.emf.ecore.impl.EClassImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceImpl;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.ui.action.ValidateAction.EclipseResourcesUtil;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryContentProvider.ViewerRefresh;
import org.eclipse.equinox.internal.app.EclipseAppContainer;
import org.eclipse.equinox.internal.app.EclipseAppDescriptor;
import org.eclipse.jface.viewers.*;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.jface.action.*;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.ui.*;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.SWT;


import aoadl.AoadlPackage;
import aoadl.Architecture;
import aoadl.Component;
import aoadl.ComponentInstance;
import aoadl.Connector;
import aoadl.ConnectorInstance;
import aoadl.DocumentRoot;
import aoadl.diagram.providers.AOADLEditPartProvider;
import aoadl.impl.*;
import aoadl.presentation.AoadlEditor;
import aoadl.provider.AOADLEditPlugin;

import org.eclipse.gmf.runtime.diagram.ui.resources.editor.document.IDiagramDocument;
import org.eclipse.gmf.runtime.diagram.ui.resources.editor.parts.*;
import org.osgi.framework.Bundle;

import prjaoadlwithcm.builder.AOADLwithCM;


/**
 * This sample class demonstrates how to plug-in a new
 * workbench view. The view shows data obtained from the
 * model. The sample creates a dummy model on the fly,
 * but a real implementation would connect to the model
 * available either in this or another plug-in (e.g. the workspace).
 * The view is connected to the model using a content provider.
 * <p>
 * The view uses a label provider to define how model
 * objects should be presented in the view. Each
 * view can present the same model objects using
 * different labels and icons, if needed. Alternatively,
 * a single label provider can be shared between views
 * in order to ensure that objects of the same type are
 * presented in the same way everywhere.
 * <p>
 */

public class AOADLwithCMTreeEditor extends ViewPart {

	/**
	 * The ID of the view as specified by the extension.
	 */
	public static final String ID = "prjaoadlwithcm.views.AOADLwithCMTreeEditor";

	private TreeViewer viewer;
	private Action action1;
	private Action action2;
	private Action refresh;
	private Action doubleClickAction;
	
	IWorkbenchPage page = null;
	DocumentRootImpl root = null;

	/*
	 * The content provider class is responsible for
	 * providing objects to the view. It can wrap
	 * existing objects in adapters or simply return
	 * objects as-is. These objects may be sensitive
	 * to the current input of the view, or ignore
	 * it and always show the same content 
	 * (like Task List, for example).
	 */
	 
	class ViewContentProvider implements ITreeContentProvider {
		
		
		@Override
		public Object[] getChildren(Object parentElement) {
			
			if(page == null) return new Object[0];
			
			ArrayList<CDOObject> listObject = new ArrayList<CDOObject>();
			if(parentElement instanceof Architecture){
				listObject.addAll(((Architecture)parentElement).getComponentInstances());
				listObject.addAll(((Architecture)parentElement).getConnectorInstances());
				return listObject.toArray();
			}
			
			if(parentElement instanceof DocumentRootImpl){
				return ((DocumentRootImpl)parentElement).getArchitectureRepository().getArchitectures().toArray();
			}
			
			return null;
		}

		@Override
		public Object getParent(Object element) {
			if(page == null) return null;
			
			if(element instanceof Architecture){
				return ((Architecture)element).getOwnerArchitectureRepository().getOwnerDocumentRoot();
			}
			
			if(element instanceof ComponentInstance){
				return ((ComponentInstance)element).getOwnerArchitecture();
			}
			
			if(element instanceof ConnectorInstance){
				return ((ConnectorInstance)element).getOwnerArchitecture();
			}
			
			return null;
		}

		@Override
		public boolean hasChildren(Object element) {
			if(page == null) return false;
			
			if(element instanceof DocumentRootImpl || element instanceof Architecture) return true;
			
			return false;
		}

		@Override
		synchronized public Object[] getElements(Object inputElement) {
			// TODO Auto-generated method stub
			//PlatformUI.getWorkbench()	.getActiveWorkbenchWindow().getActivePage();
		

			/*Thread2getPage thread = new Thread2getPage();
			thread.start();
			try {
				this.wait(1000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			page = thread.getPage();*/
			
			/*page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();*/
			
			if(page == null) return null;
			
			Object[] editor = page.getEditorReferences();
			IEditorReference diagram = null;
			
			for (int i = 0; i < editor.length; i++) {
				if(page.getActiveEditor().getTitle().equals(((IEditorReference)editor[i]).getTitle())){
					diagram = (IEditorReference)editor[i];
				}
			}
			//IEditorReference diagram = (IEditorReference)page.getActivePartReference().getPartName();
			String str= page.getActiveEditor().getTitle();
			
			
			ArrayList<CDOObject> listInstances = new ArrayList<CDOObject>(); 
			
			if(diagram.getPart(false) instanceof DiagramDocumentEditor){

				DiagramDocumentEditor aoadlEditor = (DiagramDocumentEditor)diagram.getPart(false);
				root = (DocumentRootImpl)aoadlEditor.getDiagram().getElement();
				
				 
				
				Collection<EObject> listCM  = ItemPropertyDescriptor.getReachableObjectsOfType((EObject)root, AoadlPackage.Literals.DOCUMENT_ROOT);
				
				listCM.remove(root);
				
				Iterator<EObject> ite = listCM.iterator();
				
				while ( ite.hasNext() )	
					listInstances.add((CDOObject)ite.next());
				
			}else if(diagram.getPart(false) instanceof AoadlEditor){
				AoadlEditor aoadlEditor = (AoadlEditor)diagram.getPart(false);
				
				if(((TreeSelection)aoadlEditor.getSelection()).getFirstElement() instanceof CDOObject){
					CDOObject objTree = (CDOObject)((CDOObject)((TreeSelection)aoadlEditor.getSelection()).getFirstElement()).eContainer(); 
					while(!(objTree instanceof DocumentRootImpl)){
						objTree = (CDOObject)objTree.eContainer();
					}
					root = (DocumentRootImpl)objTree;

				}else{
					XMIResourceImpl xmiResource = (XMIResourceImpl)((TreeSelection)aoadlEditor.getSelection()).getFirstElement();
					root = (DocumentRootImpl)xmiResource.getContents().get(0);
					
				}
				//DocumentRootImpl obj = (DocumentRootImpl)((CDOObject)(TreeSelection)aoadlEditor.getSelection()).eContainer();
				
				Collection<EObject> listCM  = ItemPropertyDescriptor.getReachableObjectsOfType((EObject)root, AoadlPackage.Literals.DOCUMENT_ROOT);
				
				listCM.remove(root);
				
				Iterator<EObject> ite = listCM.iterator();
				
				while ( ite.hasNext() )	
					listInstances.add((CDOObject)ite.next());

			}
			
			/*try{
				
				for (int i = 0; i < root.getArchitectureRepository().getArchitectures().size(); i++) {
					listInstances.add(root.getArchitectureRepository().getArchitectures().get(i));
					Architecture arch = root.getArchitectureRepository().getArchitectures().get(i);
					for (int j = 0; j < arch.getComponentInstances().size(); j++) {
						listInstances.add(arch.getComponentInstances().get(j));
					}
					for (int j = 0; j < arch.getConnectorInstances().size(); j++) {
						listInstances.add(arch.getConnectorInstances().get(j));
					}
				}
				
			}catch (NullPointerException e){
				
			}*/
			
			return listInstances.toArray();
		}

		@Override
		public void dispose() {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
			// TODO Auto-generated method stub
			
		}
		
	}
	
/*	class Thread2getPage extends Thread{
		IWorkbenchPage page = null;
		public IWorkbenchPage getPage() {
			return page;
		}
		public void run() {
			while(page == null){
				try {
					page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
					sleep(100);
				}catch (NullPointerException e){
						
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
			AOADLwithCMTreeEditor.this.notify();
		}
	}*/
	
	
	
	class ViewLabelProvider implements ILabelProvider{
		
		public Image getImage(Object obj) {
			
			String path = "";
			
			final Bundle bundle = Platform.getBundle("prjAOADLwithCM");
			
			if(bundle.getLocation().contains("reference:file:/")){
				path = bundle.getLocation().replace("reference:file:/", "");
			}else if(bundle.getLocation().contains("reference:file:plugins/")){
/*				path = bundle.getLocation().replace("reference:file:plugins/", "");
				path = ResourcesPlugin.getPlugin().getBundle().getHeaders().Location() + path;
*/			
				try {
					path = FileLocator.resolve(
							bundle.
							getEntry("/")).getPath();
				} catch(IOException ioe) {
					ioe.printStackTrace();
				}
				
				
				path = path.replace("file:/", "");
				path = path.substring(0,path.length()-1);
				
				path = path.substring(0, path.lastIndexOf("/"))+"/prjaoadlwithcm/";
				
			}
			
			
			
			//path = URI.create("bundleentry://"+AOADLwithCMTreeEditor.class.getResource("teste.txt").getHost()+"/").toString();
			
			
			/*try {
				path = FileLocator.resolve(
						bundle.
						getEntry("/")).getPath();
			} catch(IOException ioe) {
				ioe.printStackTrace();
			}*/
			
			//path = "platform:/plugin/";
			//path = path.replace("file:/", "");
			//path = path.replace("!", "");
			//path = path.replace("/", "");
			
		
			//path =  ((BundleHost)bundle).getBundleData().getLocation().concat("/");
			
			//path = AOADLwithCMTreeEditor.class.getResource("teste.txt").getHost();
			
			/*URL entry = bundle.getEntry(".");
			try{
			if (entry != null){
				URLConnection connection = entry.openConnection();
				if (connection instanceof BundleURLConnection){
					URL fileURL = ((BundleURLConnection) connection).getFileURL();
					URI uri = new URI(fileURL.toString());
					path = new File(uri).getPath().concat("/");
					System.out.printf("This is the path: %s\n", path);
				}
			} 
			}catch(Exception e){
				
			}*/


			if(obj instanceof DocumentRootImpl){
				path = path.concat("icons/root_tree.gif");
			}
			if(obj instanceof Architecture){
				path = path.concat("icons/architecture.gif");
			}
			
			if(obj instanceof ComponentInstance){
				path = path.concat("icons/Component.gif");
			}
			
			if(obj instanceof ConnectorInstance){
				path = path.concat("icons/connector.gif");
			}
			
			Image image = null;
			image = new Image(getSite().getShell().getDisplay(), path);
			
	          return image;
		}

		@Override
		public String getText(Object element) {
			// TODO Auto-generated method stub
			
			if(element == null) return "";
			
			if(element instanceof DocumentRootImpl){
				return "root";
			}
			if(element instanceof Architecture){
				return ((Architecture)element).getName();
			}
			
			if(element instanceof ComponentInstance){
				return ((ComponentInstance)element).getName();
			}
			
			if(element instanceof ConnectorInstance){
				return ((ConnectorInstance)element).getName();
			}
			
			return "";
		}

		@Override
		public void addListener(ILabelProviderListener listener) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void dispose() {
			// TODO Auto-generated method stub
			
		}

		@Override
		public boolean isLabelProperty(Object element, String property) {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public void removeListener(ILabelProviderListener listener) {
			// TODO Auto-generated method stub
			
		}
	}
	class NameSorter extends ViewerSorter {
	}

	/**
	 * The constructor.
	 */
	public AOADLwithCMTreeEditor() {
	}

	/**
	 * This is a callback that will allow us
	 * to create the viewer and initialize it.
	 */
	public void createPartControl(Composite parent) {
		viewer = new TreeViewer(parent, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
		
		page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
		
		/*if(page != null){
			viewer.getTree().setLayoutData(new GridData(GridData.FILL_BOTH));
			viewer.setContentProvider(new ViewContentProvider());
			viewer.setLabelProvider(new ViewLabelProvider());
			//viewer.setSorter(new NameSorter());
			viewer.setInput(getViewSite());
		}*/
		// Create the help context id for the viewer's control
		PlatformUI.getWorkbench().getHelpSystem().setHelp(viewer.getControl(), "prjAOADLwithCM.viewer");
		makeActions();
		hookContextMenu();
		hookDoubleClickAction();
		contributeToActionBars();
	}

	private void hookContextMenu() {
		MenuManager menuMgr = new MenuManager("#PopupMenu");
		menuMgr.setRemoveAllWhenShown(true);
		menuMgr.addMenuListener(new IMenuListener() {
			public void menuAboutToShow(IMenuManager manager) {
				AOADLwithCMTreeEditor.this.fillContextMenu(manager);
			}
		});
		Menu menu = menuMgr.createContextMenu(viewer.getControl());
		viewer.getControl().setMenu(menu);
		getSite().registerContextMenu(menuMgr, viewer);
	}

	private void contributeToActionBars() {
		IActionBars bars = getViewSite().getActionBars();
		fillLocalPullDown(bars.getMenuManager());
		fillLocalToolBar(bars.getToolBarManager());
	}

	private void fillLocalPullDown(IMenuManager manager) {
		manager.add(action1);
		manager.add(action2);
		manager.add(new Separator());
		manager.add(refresh);
	}

	private void fillContextMenu(IMenuManager manager) {
		manager.add(action1);
		manager.add(action2);
		manager.add(refresh);
		// Other plug-ins can contribute there actions here
		manager.add(new Separator(IWorkbenchActionConstants.MB_ADDITIONS));
	}
	
	private void fillLocalToolBar(IToolBarManager manager) {
		manager.add(action1);
		manager.add(action2);
		manager.add(refresh);
	}

	private void makeActions() {
		action1 = new Action() {
			public void run() {
				ISelection selection = viewer.getSelection();
				Object obj = ((IStructuredSelection)selection).getFirstElement();
				
				if(obj instanceof ComponentInstance){
					ComponentInstance compInst = (ComponentInstance)obj; 
					Component comp = AoadlFactoryImpl.eINSTANCE.createComponent();
					comp.setName(compInst.getName());
					comp.getClassifier().add(compInst);
					
					root.getComponentRepository().getComponents().add(comp);
					
					return;
				}
				
				if(obj instanceof ConnectorInstance){
					ConnectorInstance cnnInst = (ConnectorInstance)obj; 
					Connector cnn = AoadlFactoryImpl.eINSTANCE.createConnector();
					cnn.setName(cnnInst.getName());
					cnn.setClassifier(cnnInst);
					
					root.getConnectorRepository().getConnectors().add(cnn);
					
					return;
				}
			}
		};
		action1.setText("Instantiate Concept");
		action1.setToolTipText("Instantiate Concept");
		action1.setImageDescriptor(PlatformUI.getWorkbench().getSharedImages().
			getImageDescriptor(ISharedImages.IMG_OBJ_ADD));
		
		action2 = new Action() {
			public void run() {
				ISelection selection = viewer.getSelection();
				List list = ((IStructuredSelection)selection).toList();
				
				if(list.get(0) instanceof ComponentInstance){
					
					Component comp = AoadlFactoryImpl.eINSTANCE.createComponent();
					comp.setName("composedInst");
					
					for (int i=0;i<list.size();i++) {
						comp.getClassifier().add((ComponentInstance)list.get(i));
					}
					
					root.getComponentRepository().getComponents().add(comp);
					
					return;
				}
				
			}
		};
		action2.setText("Instantiate Composed Concepts");
		action2.setToolTipText("Instantiate Concepts");
		action2.setImageDescriptor(PlatformUI.getWorkbench().getSharedImages().
		getImageDescriptor(ISharedImages.IMG_OBJ_ELEMENT));
		
		refresh = new Action() {
			public void run() {
				//Object obj = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
				page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
				
				if(page != null){
					viewer.getTree().setLayoutData(new GridData(GridData.FILL_BOTH));
					viewer.setContentProvider(new ViewContentProvider());
					viewer.setLabelProvider(new ViewLabelProvider());
					//viewer.setSorter(new NameSorter());
					viewer.setInput(getViewSite());
				}
				//PlatformUI.getWorkbench().getHelpSystem().se(this);
				viewer.getTree().redraw();
				//viewer.getTree().getMonitor().

			}
		};
		refresh.setText("Refresh");
		refresh.setToolTipText("Refresh Tree View");
		refresh.setImageDescriptor(PlatformUI.getWorkbench().getSharedImages().
			getImageDescriptor(ISharedImages.IMG_ELCL_SYNCED));

		doubleClickAction = new Action() {
			public void run() {
				ISelection selection = viewer.getSelection();
				Object obj = ((IStructuredSelection)selection).getFirstElement();
				
				if(obj instanceof ComponentInstance){
					ComponentInstance compInst = (ComponentInstance)obj; 
					Component comp = AoadlFactoryImpl.eINSTANCE.createComponent();
					comp.setName(compInst.getName());
					comp.getClassifier().add(compInst);
					
					root.getComponentRepository().getComponents().add(comp);
					
					return;
				}
				
				if(obj instanceof ConnectorInstance){
					ConnectorInstance cnnInst = (ConnectorInstance)obj; 
					Connector cnn = AoadlFactoryImpl.eINSTANCE.createConnector();
					cnn.setName(cnnInst.getName());
					cnn.setClassifier(cnnInst);
					
					root.getConnectorRepository().getConnectors().add(cnn);
					
					return;
				}
				
				
				//showMessage("Double-click detected on "+obj.toString());
			}
		};
	}

	private void hookDoubleClickAction() {
		viewer.addDoubleClickListener(new IDoubleClickListener() {
			public void doubleClick(DoubleClickEvent event) {
				doubleClickAction.run();
			}
		});
	}
	private void showMessage(String message) {
		MessageDialog.openInformation(
			viewer.getControl().getShell(),
			"AOADLwithCM View",
			message);
	}

	/**
	 * Passing the focus request to the viewer's control.
	 */
	public void setFocus() {
		viewer.getControl().setFocus();
	}
}